dim paldata as ubyte ptr
dim as string key
dim as integer poff, pallen

open command$(1) for binary access read as #1

pallen = lof(1)
paldata = allocate(lof(1))

get #1, , *paldata, lof(1)

close #1

screenres 320, 240, 32

do
  cls
  for i as integer = 0 to 15
    for j as integer = 0 to 15
      locate i + 1, j + 1
      if poff + ((i * 16) + j) * 3 + 2 < pallen then
        color (rgb(paldata[poff + ((i * 16) + j) * 3], paldata[poff + ((i * 16) + j) * 3 + 1], paldata[poff + ((i * 16) + j) * 3 + 2]) * 3)
        print "X"
      else
        color &hff0000
        print "E"
      end if
    next
  next
  
  color &hffffff
  print
  print "offset", poff / 3
  print "lenght", pallen / 3
  print "[-] & [+]", "shift whole palette"
  print "[/] & [*]", "shift one color"
  print "[0] & [.]", "shift one byte"
  
  key = chr$(getkey)
  
  select case key
  case "+"
    poff += 256 * 3
  case "-"
    poff -= 256 * 3
  case "*"
    poff += 3
  case "/"
    poff -= 3
  case "."
    poff += 1
  case "0"
    poff -= 1
  end select
  if poff < 0 then
    poff = 0
  end if
loop until key = chr$(27)
