'' shapesz.dat 4dbf8

declare function load_palette(pal() as uinteger) as ubyte
declare function usage as ubyte

print "TyrShape v0.1.0 [Mindless]"
print

dim as ubyte ptr cmp
dim as uinteger b, p, cmp_size

dim as ubyte f = freefile
if open(command$(1) for binary access read as #f) then usage
cmp_size = lof(f)
cmp = allocate(cmp_size)
get #f, , *cmp, cmp_size
close f

dim as uinteger pal(255)
if load_palette(pal()) then
  screen -1
  print "palette.dat was not found"
  end
end if

screenres 24 * 10, 28 * 60, 24

paint (0, 0), rgb(191, 220, 191)

dim as ushort x, y, v, h

do
  do until cmp[p] = 0
    v += cmp[p]
    p += 1
  loop
  p += 1
  
  if v >= 10 then h += v \ 10
  v mod= 10
  if h >= 60 then exit do
  
  for y = 0 to (28 - 1)
    for x = 0 to (24 - 1)
      if cmp[p] then pset ((v * 24) + x, (h * 28) + y), pal(cmp[p])
      p += 1
    next
  next
  
  v += 1
  
loop while p < cmp_size

bsave command$(1) & ".bmp", 0
'sleep

function load_palette(pal() as uinteger) as ubyte
  dim as ubyte fh = freefile
  if open("palette.dat" for binary access read as #fh) then
    if open(exepath & "\palette.dat" for binary access read as #fh) then return 1
  end if
  seek #fh, 1280 * 3 + 1
  dim as ushort i
  dim as ubyte r, g, b
  for i = 0 to 255
    get #fh, , r, 1
    get #fh, , g, 1
    get #fh, , b, 1
    pal(i) = rgb(r * 4, g * 4, b * 4)
  next
  close #fh
  return 0
end function

function usage() as ubyte
  print command$(0) & " [file.dat]"
  end
  return 0
end function
