declare function load_palette(pal() as uinteger) as ubyte

select case command(1)
case "-v"
  print "tyrshp v0.1.1 [Mindless]"
case ""
  print "tyrshp shpfile"
case else
end select

dim as ushort i, j

dim as ubyte ptr cmp
dim as uinteger b, p, cmp_size

dim as ushort off(16 * 19)

dim as ubyte f = freefile

if open(command$(1) for binary access read as #f) then
  print "failed to read " & command$(1)
  end
end if
/'b = val(command$(2))'/
cmp_size = lof(f) /'- b'/
cmp = allocate(cmp_size)
get #f, /'b +'/ 1, *cmp, cmp_size
close #f


dim as uinteger pal(255)
if load_palette(pal()) then
  print "palette.dat was not found"
  end
end if

print command(1) & " -> " & command(1) & ".bmp"

screenres 228, 224, 24

dim as ubyte x, y, v, h
dim as ubyte cmd, temp

p = 0 : b = 0

/'do while p < cmp_size'/
  
  cls
  paint (0, 0), rgb(191, 220, 191)
  
  for i = 0 to (&h260 / 2) - 1
    off(i) = (cmp[p] or (cmp[p + 1] shl 8))
    p += 2
  next
  
  do while p < cmp_size and (h < 16)
    
    if cmp[p] = &h0f then
      p += 1
      y = 0 : x = 0
      
      v += 1
      v = v mod 19
      if v = 0 then h += 1
      off(304) = p - b
      p = off(h * 19 + v) + b
      
    else
      
      cmd = cmp[p]
      p += 1
      
      x += cmd and &h0f
      temp = (cmd shr 4) and &h0f
      
      select case temp
      case &h0
        x -= 12 : y += 1
      case &h1 to &hf
        for j = 1 to temp
          pset ((v * 12) + x, (h * 14) + y), pal(cmp[p])
          x += 1
          p += 1
        next
      end select
      
    end if
    
  loop
  
  bsave command$(1) /'& "." & hex(b, 6)'/ & ".bmp", 0
  'sleep
  
/'  h = 0 : v = 0 : b = p
  
loop'/

deallocate cmp

'sleep

end


function load_palette(pal() as uinteger) as ubyte
  dim as ubyte fh = freefile
  if open("palette.dat" for binary access read as #fh) then
    if open(exepath & "\palette.dat" for binary access read as #fh) then return 1
  end if
  seek #fh, 1280 * 3 + 1
  dim as ushort i
  dim as ubyte r, g, b
  for i = 0 to 255
    get #fh, , r, 1
    get #fh, , g, 1
    get #fh, , b, 1
    pal(i) = rgb(r * 4, g * 4, b * 4)
  next
  close #fh
  return 0
end function
